searchData={"items":[{"type":"module","title":"Green.Function.Signature","doc":"This module defines a struct that represents a function signature.","ref":"Green.Function.Signature.html"},{"type":"function","title":"Green.Function.Signature.new/3","doc":"","ref":"Green.Function.Signature.html#new/3"},{"type":"module","title":"Green.Lexmag.ElixirStyleGuideFormatter","doc":"","ref":"Green.Lexmag.ElixirStyleGuideFormatter.html"},{"type":"function","title":"Green.Lexmag.ElixirStyleGuideFormatter.format_file/1","doc":"","ref":"Green.Lexmag.ElixirStyleGuideFormatter.html#format_file/1"},{"type":"module","title":"Green.Quoted","doc":"Conveniences for modifying the AST and associated comments.","ref":"Green.Quoted.html"},{"type":"function","title":"Green.Quoted.new_position/3","doc":"","ref":"Green.Quoted.html#new_position/3"},{"type":"function","title":"Green.Quoted.shift/4","doc":"","ref":"Green.Quoted.html#shift/4"},{"type":"module","title":"Green.Quoted.Comments","doc":"Conveniences for modifying parsed comments.","ref":"Green.Quoted.Comments.html"},{"type":"function","title":"Green.Quoted.Comments.line_comments/2","doc":"","ref":"Green.Quoted.Comments.html#line_comments/2"},{"type":"function","title":"Green.Quoted.Comments.move_line/3","doc":"","ref":"Green.Quoted.Comments.html#move_line/3"},{"type":"function","title":"Green.Quoted.Comments.sort/1","doc":"","ref":"Green.Quoted.Comments.html#sort/1"},{"type":"module","title":"Green.Quoted.Forms","doc":"Conveniences for modifying the AST.","ref":"Green.Quoted.Forms.html"},{"type":"function","title":"Green.Quoted.Forms.move_line/3","doc":"","ref":"Green.Quoted.Forms.html#move_line/3"},{"type":"module","title":"Green.Quoted.FormsAndComments","doc":"Conveniences for modifying the AST and associated comments.","ref":"Green.Quoted.FormsAndComments.html"},{"type":"function","title":"Green.Quoted.FormsAndComments.move/3","doc":"Move a line in the AST and associated comments.\n\nAny comments immediately preceding the given line are moved to\nthe given destination `to` line. The line itself is moved to\nthe following line.","ref":"Green.Quoted.FormsAndComments.html#move/3"},{"type":"behaviour","title":"Green.Rule","doc":"This is the Rule behaviour.","ref":"Green.Rule.html"},{"type":"callback","title":"Green.Rule.apply/2","doc":"","ref":"Green.Rule.html#c:apply/2"},{"type":"type","title":"Green.Rule.comment/0","doc":"","ref":"Green.Rule.html#t:comment/0"},{"type":"type","title":"Green.Rule.forms/0","doc":"","ref":"Green.Rule.html#t:forms/0"},{"type":"module","title":"Green.Rules.Exceptions.UseErrorSuffix","doc":"This cop warns if exceptions are defined with a suffix of `Error`.","ref":"Green.Rules.Exceptions.UseErrorSuffix.html"},{"type":"module","title":"Examples - Green.Rules.Exceptions.UseErrorSuffix","doc":"defmodule MyBad do\n      defexception message: \"some error message\"\n    end\n\nIn the example above, the exception should be named `MyBadError`.","ref":"Green.Rules.Exceptions.UseErrorSuffix.html#module-examples"},{"type":"module","title":"Green.Rules.Linting.AvoidNeedlessPipelines","doc":"This cop transforms single-function pipelines into function calls.","ref":"Green.Rules.Linting.AvoidNeedlessPipelines.html"},{"type":"module","title":"Green.Rules.Linting.NoNilElse","doc":"This module removes `else` clauses that return `nil`.","ref":"Green.Rules.Linting.NoNilElse.html"},{"type":"module","title":"Green.Rules.Linting.NoUnlessWithElse","doc":"This cop transforms `unless` with `else` into `if` with `else`.","ref":"Green.Rules.Linting.NoUnlessWithElse.html"},{"type":"module","title":"Green.Rules.Linting.PreferPipelines","doc":"This rule transforms nested function calls into pipelines.","ref":"Green.Rules.Linting.PreferPipelines.html"},{"type":"module","title":"Green.Rules.Linting.TrueInCond","doc":"This cop ensures final, always-matching clauses in `cond` use `true`.","ref":"Green.Rules.Linting.TrueInCond.html"},{"type":"module","title":"Green.Rules.Linting.UseStringConcatenationWhenMatchingBinaries","doc":"This cop replaces use of bitstrings with the `<>` operator when matching binaries.","ref":"Green.Rules.Linting.UseStringConcatenationWhenMatchingBinaries.html"},{"type":"module","title":"Green.Rules.Modules.SortReferences","doc":"","ref":"Green.Rules.Modules.SortReferences.html"},{"type":"module","title":"Green.Rules.Modules.UseModulePseudoVariable","doc":"This cop replaces references to the current module by name with the pseudo-variable\n`__MODULE__`.","ref":"Green.Rules.Modules.UseModulePseudoVariable.html"},{"type":"module","title":"Green.Rules.Naming.AvoidCaps","doc":"This module prints warnings when capital letters are used in atoms, functions, variables or\nattributes.","ref":"Green.Rules.Naming.AvoidCaps.html"},{"type":"function","title":"Green.Rules.Naming.AvoidCaps.capital?/1","doc":"","ref":"Green.Rules.Naming.AvoidCaps.html#capital?/1"},{"type":"module","title":"Green.Rules.Naming.AvoidOneLetterVariables","doc":"This module prints a warning if there are one-letter variable names.","ref":"Green.Rules.Naming.AvoidOneLetterVariables.html"},{"type":"module","title":"Green.Rules.Structs.RemoveNilFromStructDefinition","doc":"This module removes `nil` defaults from struct definitions.","ref":"Green.Rules.Structs.RemoveNilFromStructDefinition.html"},{"type":"extras","title":"Green","doc":"# Green\n\n![Version](https://img.shields.io/hexpm/v/green)\n\nAn Elixir code formatter.\n\nCurrently, it can enforce [lexmag's Elixir style guide][lexmag].\n\n[lexmag]: https://github.com/lexmag/elixir-style-guide","ref":"readme.html"},{"type":"extras","title":"Motivation - Green","doc":"The standard Elixir formatter only enforces a small number of rules.\nThis project aims to enforce enough rules so that the \"house style\" of a project\ncan be enforced by the formatter.","ref":"readme.html#motivation"},{"type":"extras","title":"Name - Green","doc":"The name \"Green\" is a reference to bikeshedding, i.e. \"All bike sheds should\nbe green.\"","ref":"readme.html#name"},{"type":"extras","title":"Status - Green","doc":"Currently, Green provides `Green.Lexmag.ElixirStyleGuideFormatter` which,\nas far as is possible, implements the rules of [lexmag's style guide][lexmag]\nthat are not already implemented by `mix format`.","ref":"readme.html#status"},{"type":"extras","title":"Limitations - Green","doc":"Two rules change the order of lines:\n\n* `PreferPipelines` groups `use`, `import`, `assign` and `require` statements,\n* `RemoveNilFromStructDefinition` places the list of `nil`-default fields\n  at the top of the struct definition.\n\nWhere possible, when shifting lines around, Green will try to keep\nassociated comments with the lines that follow them. However, this is not\nalways possible. Please check the output of the formatter to ensure that\ncomments are in the correct place.","ref":"readme.html#limitations"},{"type":"extras","title":"Roadmap - Green","doc":"Implement the other well-known Elixir style guides:\n\n* [Credo's Style Guide](https://github.com/rrrene/elixir-style-guide#readme)\n* [Christopher Adams' Elixir Style Guide](https://github.com/christopheradams/elixir_style_guide)","ref":"readme.html#roadmap"},{"type":"extras","title":"Lexmag.ElixirStyleGuideFormatter - Green","doc":"","ref":"readme.html#lexmag-elixirstyleguideformatter"},{"type":"extras","title":"Usage - Green","doc":"Add the following to your `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    {:green, \"~> (See the badge above)\"}\n  ]\nend\n```\n\nModify `.formatter.exs` to include the following:\n\n```elixir\n[\n  plugins: [Green.Lexmag.ElixirStyleGuideFormatter]\n]\n```","ref":"readme.html#usage"},{"type":"extras","title":"Limitations - Green","doc":"The implemented rules are marked with a check `✅`.\n\nWhen it is possible to transform the code to match the style guide, Green will\ndo so. However, it is not always possible to do so. In these cases, Green will\nleave the code as it is and print a warning. These are marked with an\nexclamation mark `❗`.\n\nRules that are not implemented are marked with a question mark `❔`. This\nincludes rules where there is no way to objectively judge them, such as\nusefulness of comments.\n\nRules that are implemented by the compiler or `mix format` are marked with\na thumbs up `👍`.","ref":"readme.html#limitations"},{"type":"extras","title":"Linting - Green","doc":"✅  Transform nested function calls into pipelines ([L1]),\n\n✅ Transform one-element pipelines into function calls ([L2]),\n\n❔ Don't use anonymous functions in pipelines ([L3]),\n\n✅ Transform `unless...else...` into `if...else...` ([L4]),\n\n✅ Transform `if...else nil` into `if...` ([L5]),\n\n✅ Ensure match-all condition of `cond` has `true` ([L6]),\n\n❔ Use `and` and `or` instead of `&&` and `||` when the arguments are boolean ([L7]),\n\n✅ Use `<>` instead of bitstrings when pattern-matching binaries ([L8]).\n\n[L1]: https://github.com/lexmag/elixir-style-guide#pipeline-operator\n[L2]: https://github.com/lexmag/elixir-style-guide#needless-pipeline\n[L3]: https://github.com/lexmag/elixir-style-guide#anonymous-pipeline\n[L4]: https://github.com/lexmag/elixir-style-guide#no-else-with-unless\n[L5]: https://github.com/lexmag/elixir-style-guide#no-nil-else\n[L6]: https://github.com/lexmag/elixir-style-guide#true-in-cond\n[L7]: https://github.com/lexmag/elixir-style-guide#boolean-operators\n[L8]: https://github.com/lexmag/elixir-style-guide#patterns-matching-binaries","ref":"readme.html#linting"},{"type":"extras","title":"Naming - Green","doc":"❗ Enforce snake_case for atoms, functions, variables, attributes ([N1]),\n\n👍 Enforce CamelCase for modules ([N2]),\n\n❔ Enforce predicate functions to end with a question mark ([N3]),\n\n✅ Enforce snake_case for directories and files ([N4]),\n\n❗ Disallow one-letter variable names ([N5]).\n\n[N1]: https://github.com/lexmag/elixir-style-guide#snake-case-atoms-funs-vars-attrs\n[N2]: https://github.com/lexmag/elixir-style-guide#camelcase-modules\n[N3]: https://github.com/lexmag/elixir-style-guide#predicate-funs-name\n[N4]: https://github.com/lexmag/elixir-style-guide#snake-case-dirs-files\n[N5]: https://github.com/lexmag/elixir-style-guide#one-letter-var","ref":"readme.html#naming"},{"type":"extras","title":"Comments - Green","doc":"❔ Use only critical comments ([C1]),\n\n❔ Avoid superfluous comments ([C2]).\n\n[C1]: https://github.com/lexmag/elixir-style-guide#critical-comments\n[C2]: https://github.com/lexmag/elixir-style-guide#no-superfluous-comments","ref":"readme.html#comments"},{"type":"extras","title":"Modules - Green","doc":"✅ Group and order `use`, `import`, `assign` and `require` statements ([M1]),\n\n✅ Replace the current module name with `__MODULE__` ([M2]).\n\nNotes:\n\n* [M1][M1]:\n  This transformation does not take into account comments. Any comment before\n  or on the same line as a `use`, `import`, `assign` or `require` statement\n  will be left where it is.\n\n[M1]: https://github.com/lexmag/elixir-style-guide#module-layout\n[M2]: https://github.com/lexmag/elixir-style-guide#current-module-reference","ref":"readme.html#modules"},{"type":"extras","title":"Regular Expressions - Green","doc":"❔ Prefer pattern matching over regular expressions ([R1]),\n\n❔ Use non-capturing regular expressions ([R2]).\n\n[R1]: https://github.com/lexmag/elixir-style-guide#pattern-matching-over-regexp\n[R2]: https://github.com/lexmag/elixir-style-guide#non-capturing-regexp","ref":"readme.html#regular-expressions"},{"type":"extras","title":"Structs - Green","doc":"✅ Don't specify `nil` default values for `defstruct` fields ([S1]).\n\n[S1]: https://github.com/lexmag/elixir-style-guide#defstruct-fields-default","ref":"readme.html#structs"},{"type":"extras","title":"Exceptions - Green","doc":"❗ Use `Error` suffix for exception names ([E1]),\n\n❔ Use non-capitalized error messages (except for Mix error messages) without trailing punctuation ([E2]).\n\n[E1]: https://github.com/lexmag/elixir-style-guide#exception-naming\n[E2]: https://github.com/lexmag/elixir-style-guide#exception-message","ref":"readme.html#exceptions"},{"type":"extras","title":"ExUnit - Green","doc":"❔ Put the expression being tested by comparison on the left side ([U1]).\n\n[U1]: https://github.com/lexmag/elixir-style-guide#exunit-assertion-side","ref":"readme.html#exunit"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.0"}}